// Implementacao de Complexo - Complexo.c

#include "complexo.h"
#include <math.h>
#include <vcl/dstring.h>
#define PI 4.0 * atan( 1.0 )

void Complexo::retanParaPolar( void )
{
  modulo = sqrt( real * real + imag * imag );
    if ( real == 0.0 ) // Evitar singularidade
    {
      if ( imag == 0.0 )
      angulo = 0.0;
    if ( imag > 0.0 )
      angulo = PI / 2.0;
    else
      angulo = -PI / 2.0;
}
  else // encontrar quadrante correto
    {
      angulo = atan ( imag / real );
      if ( ( real < 0.0 ) && ( imag < 0.0 ) )
	angulo -= PI;
      if ( ( real < 0.0 ) && ( imag > 0.0 ) )
	angulo += PI;
    }
}
void Complexo::polarParaRetan( void )
{
  real = modulo * cos( angulo );
  imag = modulo * sin( angulo );
}
ostream& operator << ( ostream& o, Complexo& c )
{
  if ( c.imag == 0 )
  {
    o <<  c.real ;
    return o;
  }
  else if ( c.imag > 0 )
  {
    o <<  c.real  << " + j";
    o <<  c.imag ;
    return o;
  }
  else
  {
    o <<  c.real  << " - j";
    o <<  -c.imag ;
    return o;
  }
  }
  AnsiString Complexo :: complexOut(void)
{
int prec=2, dig=10;
// AnsiString:: TFloatFormat form=AnsiString::sffGeneral;
 if ( this->obterImag() == 0 )
  {
    return (FloatToStrF(this->obterReal(),00.00,prec,dig));
  }
  else if ( this->obterImag() > 0 )
  {
        return (FloatToStrF(this->obterReal(),00.00,prec,dig)+
                "+"+FloatToStrF(this->obterImag(),00.00,prec,dig)+" j");
  }
  else
  {

    return (FloatToStrF(this->obterReal(),00.00,prec,dig)+
                "-"+FloatToStrF(-this->obterImag(),00.00,prec,dig)+" j");
  }

}