// Interface para classe Complexo - Complexo.h
#include <iostream.h>
#include <system.hpp>
#include <vcl.h>
#include <math.h>

class Complexo
{
  private:
    float real;
    float imag;
    float modulo;
    float angulo;
    void retanParaPolar( void );
    void polarParaRetan( void );

  public:
    Complexo( float umReal, float umaimag ) : real(umReal),
      imag( umaimag )
    {
      retanParaPolar();
    }

    Complexo( float Modulo, float Angulo, int dummy ) :
	      modulo( Modulo ), angulo( Angulo )
    {
      polarParaRetan();
    }

    Complexo( void ) {real = imag = modulo = angulo = 0.0;}

    Complexo( float umReal ) : real( umReal ) , imag( 0.0 )
    {
      retanParaPolar();
    }
~Complexo( void ) { }

float obterReal( void ) { return real; }

float obterImag( void ) { return imag; }

float obterModulo( void ) { return modulo; }

float obterAngulo( void ) { return angulo; }

void definirReal( float umReal )
{
real = umReal;
retanParaPolar();
}

void definirImag( float umaimag )
{
imag = umaimag;
retanParaPolar();
}

void definirModulo( float m )
{
modulo = m;
polarParaRetan();
}

void definirAngulo (float a )
{
angulo = a;
polarParaRetan();
}

friend ostream& operator << (ostream& o, Complexo& c);

friend Complexo operator + (Complexo& c1, Complexo& c2);

friend Complexo operator * (Complexo& c1, Complexo& c2);

friend Complexo operator - (Complexo &c1, Complexo& c2);

// final de delcarao da classe

friend Complexo operator / (Complexo &c1, Complexo& c2);
AnsiString complexOut(void);
};

inline Complexo operator + (Complexo& c1, Complexo& c2)
{
return Complexo( c1.real + c2.real, c1.imag + c2.imag );
}

inline Complexo operator * (Complexo& c1, Complexo& c2)
{
return Complexo( c1.modulo * c2.modulo, c1.angulo +
		 c2.angulo, 0 );
}

inline Complexo operator - (Complexo& c1, Complexo& c2)
{
return Complexo( c1.real - c2.real, c1.imag - c2.imag );
}

inline Complexo operator / (Complexo& c1, Complexo& c2)
{
return Complexo( c1.modulo / c2.modulo, c1.angulo -
		 c2.angulo, 0 );
}


